/* -*- C++ -*-
 * $Id: flimage.h,v 1.11 2002/06/01 01:46:35 ttate Exp $
 */

#ifndef RBFLIMAGE_H
#define RBFLIMAGE_H

#include <FL/Fl_Image.H>
#include <FL/Enumerations.H>

#if FLTK_VERSION >= FLTK_VERSION_CODE(1,1,0)
# include <FL/Fl_PNG_Image.H>
# include <FL/Fl_JPEG_Image.H>
# include <FL/Fl_BMP_Image.H>
# include <FL/Fl_Shared_Image.H>
# include <FL/Fl_Tiled_Image.H>
#endif

#include "flwidget.h"

extern VALUE rb_cFLImage;
extern VALUE rb_cFLRGB_Image;
extern VALUE rb_cFLPNG_Image;
extern VALUE rb_cFLJPEG_Image;
extern VALUE rb_cFLBMP_Image;
extern VALUE rb_cFLTiled_Image;
extern VALUE rb_cFLShared_Image;

#if FLTK_VERSION < FLTK_VERSION_CODE(1,1,0)

class RBFLImage : public Fl_Image {
public:
  RBFLImage(uchar *img, int w, int h, int d = 3, int ld = 0)
    : Fl_Image((const uchar*)img,w,h, d, ld){};
};

#else

class RBFLImage : public Fl_Image {
public:
#if defined(HAVE_FL_IMAGE_3)
  RBFLImage(int w, int h, int d) : Fl_Image(w,h,d){};
#else
  RBFLImage(int w, int h, int d) : Fl_Image(w,h){};
#endif
};

class RBFLRGB_Image : public Fl_RGB_Image {
public:
  RBFLRGB_Image(uchar *img, int w, int h, int d = 3, int ld = 0)
    : Fl_RGB_Image((const uchar*)img,w,h, d, ld){};
};

class RBFLPNG_Image : public Fl_PNG_Image {
public:
  RBFLPNG_Image(const char *filename) : Fl_PNG_Image(filename) {};
};

class RBFLJPEG_Image : public Fl_JPEG_Image {
public:
  RBFLJPEG_Image(const char *filename) : Fl_JPEG_Image(filename) {};
};

class RBFLBMP_Image : public Fl_BMP_Image {
public:
  RBFLBMP_Image(const char *filename) : Fl_BMP_Image(filename) {};
};

class RBFLShared_Image : public Fl_Shared_Image {
  // empty?  
};

class RBFLTiled_Image : public Fl_Tiled_Image {
public:
  RBFLTiled_Image(Fl_Image *i, int w = 0, int h = 0) : Fl_Tiled_Image(i,w,h){};
};

#endif /* USE_RGB_IMAGE */

extern "C" void Init_flimage();

#endif /* RBFLIMAGE_H */
