/* -*- C++ -*-
 * $Id: flwidget.h,v 1.28 2002/10/21 16:09:19 ttate Exp $
 */

#ifndef RBFLWIDGET_H
#define RBFLWIDGET_H

#include <FL/Fl_Widget.H>
#include <ruby.h>
#include "fltk.h"

typedef void (*RBFLMarkFunc)(VALUE);

extern "C" {
void rb_fltk_add_mark(VALUE klass, RBFLMarkFunc);
void rb_fltk_append_mark(VALUE klass, RBFLMarkFunc);
VALUE rb_fl_new(VALUE klass, Fl_Widget *w);
VALUE rb_fl_destroy(VALUE self);
VALUE rb_fl_destroyed(VALUE self);
VALUE rb_fl_check(VALUE self);
VALUE rb_fl_check_widget(VALUE self);
VALUE rb_fl_callback(VALUE self);
Fl_Widget *rb_to_fl(VALUE self);
VALUE fl_to_rb(Fl_Widget *);
}


class RBFLWidget : public Fl_Widget
{
public:
  RBFLWidget(int x, int y, int w, int h, const char *label = 0)
    : Fl_Widget(x,y,w,h,label){};
  RBFL_WIDGET_CALLERS(Fl_Widget);

  void draw_box() const {
    Fl_Widget::draw_box();
  }

  void draw_box(Fl_Boxtype t, Fl_Color c) const {
    Fl_Widget::draw_box(t, c);
  }

  void draw_box(Fl_Boxtype t, int x , int y, int w, int h, Fl_Color c) const {
    Fl_Widget::draw_box(t, x, y, w, h, c);
  }

  void draw_label() const {
    Fl_Widget::draw_label();
  }

  void draw_label(int x, int y, int w, int h) const {
    Fl_Widget::draw_label(x, y, w, h);
  }
};

extern VALUE rb_cFLWidget;

extern "C" void Init_flwidget(void);

#endif /* RBFLWIDGET_H */
