# $Id: install.rb,v 1.13 2006/12/31 11:58:22 jeremy_henty Exp $

require 'mkmf'
require 'ftools'

FLLIB = "rubyfltk.so"
GLLIBS = ["opengl.so", "glut.so"]

$ruby_version = CONFIG['MAJOR'] + "." + CONFIG['MINOR']
$prefix = CONFIG['prefix']
$libdir = File.join($prefix,'lib')
$rubylibdir = File.join($libdir, 'ruby', $ruby_version)
$arch = CONFIG['arch']
$archdir = File.join($rubylibdir, $arch)

def find(dir, match = /./)
  Dir.chdir(dir)
  files = []
  Dir.new(".").each{|file|
    if( file != "." && file != ".." )
      case File.ftype(file)
      when "file"
	if( file =~ match )
	  files.push(File.join(dir,file))
	end
      when "directory"
	files += find(file, match).collect{|f| File.join(dir,f)}
      end
    end
  }
  Dir.chdir("..")
  return files
end

def install()
  rbfiles = find(File.join(".","lib"), /.rb$/)

  File.makedirs($rubylibdir, "#{$archdir}")
  File.install(FLLIB, File.join($archdir,FLLIB), 0555, true)

  File.makedirs(File.join($rubylibdir,"fltk"))
  rbfiles.each{|f|
    origfile = f
    instfile = File.join($rubylibdir, origfile.sub("./lib/",""))
    instdir  = File.dirname(instfile)
    File.makedirs(instdir)
    File.install(origfile, instfile, 0644, true)
  }

  GLLIBS.each{|lib|
    $stdout.print("Install #{lib}? [y/n]")
    $stdout.flush
    if( $stdin.gets =~ /^y/i )
      File::install(lib, File.join($archdir, lib), 0555, true)
    end
  }
end

install()
