# $Id: clip.rb,v 1.3 2006/12/31 11:58:23 jeremy_henty Exp $

# This program is a part of the Ruby/FLTK tests.
# Author:: Jeremy Henty <mailto:jeremy_henty@users.sourceforge.net>
# Copyright:: Copyright (c) 2006 Jeremy Henty 
# License:: LGPL

require 'fltk'

class Clip_Window < FLTK::Window
  def draw
    margin = 20
    FLTK.push_clip(margin,
                   margin,
                   w-2*margin,
                   h-2*margin){
      super
      FLTK.font(FLTK::HELVETICA,15)
      FLTK.color(FLTK::BLACK)
      text = "This text was clipped. " * 3
      20.times{|ii| FLTK.draw(text,-20*ii,15*ii) }
      FLTK.push_no_clip {
        FLTK.font(FLTK::HELVETICA,15) 
        FLTK.color(FLTK::RED) 
        text = "NOT CLIPPED - " * 10
        FLTK.draw(text,-20,h/2)
      }
    }
  end
end

Clip_Window.new(200,200,"Clipping"){|win|
  win.show
}

FLTK.run
