# $Id: color.rb,v 1.3 2006/12/31 11:58:23 jeremy_henty Exp $

# This program is a part of the Ruby/FLTK tests.
# Author:: Jeremy Henty <mailto:jeremy_henty@users.sourceforge.net>
# Copyright:: Copyright (c) 2005, 2006 Jeremy Henty 
# License:: LGPL

=begin

Exercise all forms of FLTK.color .

=end

require 'fltk'

class Widget < FLTK::Widget

  attr_reader :display_proc

  def initialize(_display_proc,*args)
    super(*args)
    @display_proc = _display_proc
  end

  def draw
    FLTK.color(FLTK::WHITE)
    display_proc.call("background color: #{FLTK.color}")
    FLTK.rectf(x,y,w,h)
    diameter = [w,h,].min
    dd = diameter * 0.2
    RGBS.each do |rgb|
      FLTK.color(*rgb)
      diameter -= dd
      _x = x + (w-diameter)/2
      _y = y + (h-diameter)/2
      FLTK.pie(_x,_y,diameter,diameter,0,360)
    end
  end

  RGBS =
    [ [ 0x24, 0x68, 0xAC, ], 
      [ 0xF4, 0x10, 0xEE, ], 
      [ 0x91, 0xAB, 0x38, ], 
      [ 0xF6, 0x70, 0x22, ], ]

end

FLTK::Window.new(400,430,"Color"){|win|
  message = nil # will set this later 
  display_proc =
  Proc.new {|color| message.label("background color: #{FLTK.color}")}
  Widget.new(display_proc,win.w,400)
  message = FLTK::Box.new(0,400,win.w,30)
  win.show
}

FLTK.run
