# $Id: color_blocks.rb,v 1.2 2006/12/31 11:58:23 jeremy_henty Exp $

# A demonstration of passing a code block to FLTK.color .  The current
# color is changed while the block executes and is then restored.

require 'fltk'

class ColorWindow < FLTK::Window

  def draw
    FLTK.color(FLTK::BLACK){
      splat(0)
      FLTK.color(FLTK::WHITE){
        splat(1)
      }
      splat(2) 
      FLTK.color(FLTK::BLUE){
          splat(3)
        FLTK.color(FLTK::GREEN){
          splat(4)
          FLTK.color(FLTK::RED){
            splat(5) 
          }
          splat(6)
        }
        splat(7)
      }
      splat(8) 
    }
  end

  def splat(_n)
    _N = 17 # twice the largest value of _n , plus one 
    FLTK.rectf((w*_n)/_N,
               (h*_n)/_N,
               (w*(_N-2*_n))/_N,
               (h*(_N-2*_n))/_N)
  end

end

ColorWindow.new(300,300,'Colors and Code Blocks'){|win|
  win.show
}

FLTK.run
