# $Id: valuators.rb,v 1.10 2007/01/09 01:14:21 jeremy_henty Exp $

#
# ported from 'fltk/test'
#

require 'fltk'

message = nil # will set this later 
pr = proc{ |o, d| message.label("%f" % o.value) }

FLTK::DoubleWindow.new(580, 540,
  "Valuator classes, showing values for type()"
){ |win|
  win.color(43)
  win.selection_color(43)

  o = FLTK::Box.new(10, 10, 280, 210, "FLTK::Slider")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::Slider.new(30, 45, 20, 145, "0")
  o.tooltip("Vertical Slider")
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)
  o.align(FLTK::ALIGN_TOP)

  o = FLTK::Slider.new(70, 55, 20, 145, "FLTK::VERT_FILL_SLIDER")
  o.widget_type(2)
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)

  o = FLTK::Slider.new(105, 45, 20, 145, "FLTK::VERT_NICE_SLIDER")
  o.widget_type(4)
  o.box(FLTK::FLAT_BOX)
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)
  o.align(FLTK::ALIGN_TOP)

  o = FLTK::Slider.new(140, 80, 130, 20, "FLTK::HORIZONTAL")
  o.widget_type(1)
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)

  o = FLTK::Slider.new(140, 120, 130, 20, "FLTK::HOR_FILL_SLIDER")
  o.widget_type(3)
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)

  o = FLTK::Slider.new(140, 160, 130, 20, "FLTK::HOR_NICE_SLIDER")
  o.widget_type(5)
  o.box(FLTK::FLAT_BOX)
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)

  o = FLTK::Box.new(10, 230, 280, 210, "FLTK::ValueSlider")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::ValueSlider.new(30, 260, 30, 145, "0")
  o.tooltip("Value Slider")
  o.selection_color(1)
  o.labelsize(8)
  o.step(0.01)
  o.callback(&pr)
  o.align(FLTK::ALIGN_TOP)

  o = FLTK::ValueSlider.new(70, 275, 30, 140, "FLTK::VERT_FILL_SLIDER")
  o.widget_type(2)
  o.selection_color(1)
  o.labelsize(8)
  o.step(0.01)
  o.callback(&pr)

  o = FLTK::ValueSlider.new(110, 260, 20, 145, "FLTK::VERT_NICE_SLIDER")
  o.widget_type(4)
  o.box(FLTK::FLAT_BOX)
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.callback(&pr)
  o.align(FLTK::ALIGN_TOP)

  o = FLTK::ValueSlider.new(140, 290, 130, 20, "FLTK::HOR_SLIDER")
  o.widget_type(1)
  o.selection_color(1)
  o.labelsize(8)
  o.step(0.01)
  o.callback(&pr)

  o = FLTK::ValueSlider.new(140, 330, 130, 20, "FLTK::HOR_FILL_SLIDER")
  o.widget_type(3)
  o.selection_color(1)
  o.labelsize(8)
  o.step(0.01)
  o.callback(&pr)

  o = FLTK::ValueSlider.new(140, 370, 130, 20, "FLTK::HOR_NICE_SLIDER")
  o.widget_type(5)
  o.box(FLTK::FLAT_BOX)
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.step(0.01)
  o.callback(&pr)

  o = FLTK::Box.new(10, 450, 135, 50, "FLTK::ValueInput")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::ValueInput.new(30, 470, 105, 25, "0")
  o.tooltip("Value Input")
  o.labelsize(8)
  o.maximum(100)
  o.step(0.1)
  o.callback(&pr)

  o = FLTK::Box.new(155, 450, 135, 50, "FLTK::ValueOutput")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::ValueOutput.new(170, 470, 105, 25, "0")
  o.tooltip("Value Output")
  o.labelsize(8)
  o.maximum(100)
  o.step(0.1)
  o.callback(&pr)

  o = FLTK::Box.new(300, 10, 130, 120, "   FLTK::Scrollbar")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::Scrollbar.new(305, 65, 95, 20, "FLTK::HORIZONTAL")
  o.tooltip("Horizontal Scrollbar")
  o.widget_type(1)
  o.labelsize(8)
  o.maximum(100)
  o.slider_size(0.3)
  o.callback(&pr)

  o = FLTK::Scrollbar.new(400, 20, 20, 105, "0")
  o.tooltip("Vertical Scrollbar")
  o.labelsize(8)
  o.maximum(100)
  o.slider_size(0.3)
  o.callback(&pr)
  o.align(FLTK::ALIGN_TOP)

  o = FLTK::Box.new(440, 10, 130, 120, "FLTK::Adjuster")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::Adjuster.new(450, 60, 75, 25, "w()>h()")
  o.tooltip("Horizontal Adjuster");
  o.labelsize(8)
  o.step(0.0001)
  o.callback(&pr)

  o = FLTK::Adjuster.new(530, 35, 25, 75, "w()<h()")
  o.tooltip("Vertical Adjuster");
  o.labelsize(8)
  o.step(0.0001)
  o.callback(&pr)

  o = FLTK::Box.new(300, 140, 130, 120, "FLTK::Counter")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::Counter.new(310, 175, 110, 25, "0")
  o.tooltip("Standard Counter")
  o.labelsize(8)
  o.step(0.1)
  o.callback(&pr)

  o = FLTK::Counter.new(310, 215, 110, 25, "FLTK::SIMPLE_COUNTER")
  o.tooltip("Simple Counter")
  o.widget_type(1)
  o.labelsize(8)
  o.step(0.1)
  o.callback(&pr)

  o = FLTK::Box.new(440, 140, 130, 120, "FLTK::Spinner")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  if FLTK.const_defined?("Spinner")

    o = FLTK::Spinner.new(465, 176, 80, 24, "FLTK::INT_INPUT")
    o.labelsize(8)
    o.minimum(-30)
    o.maximum(30)
    o.step(2)
    o.value(5)
    o.align(FLTK::ALIGN_BOTTOM)
    o.callback(&pr)

    o = FLTK::Spinner.new(465, 216, 80, 24, "FLTK::FLOAT_INPUT")
    o.spinner_type(1)
    o.labelsize(8)
    o.minimum(0)
    o.maximum(1)
    o.step(0.01)
    o.value(0.05)
    o.align(FLTK::ALIGN_BOTTOM)
    o.callback(&pr)

  else

    o = FLTK::Box.new(465, 175, 80, 70, "Not Implemented")
    o.box(FLTK::ENGRAVED_BOX)
    o.labelfont(1)

  end

  o = FLTK::Box.new(300, 270, 270, 105, "FLTK::Dial")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::Dial.new(320, 295, 65, 65, "0")
  o.tooltip("Standard Dial")
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.value(0.5)
  o.angles(0,315)
  o.callback(&pr)

  o = FLTK::Dial.new(400, 295, 65, 65, "FLTK::LINE_DIAL")
  o.tooltip("Line Dial")
  o.widget_type(1)
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.value(0.5)
  o.callback(&pr)

  o = FLTK::Dial.new(480, 295, 65, 65, "FLTK::FILL_DIAL")
  o.tooltip("Fill Dial")
  o.widget_type(2)
  o.color(10)
  o.selection_color(1)
  o.labelsize(8)
  o.value(1)
  o.angles(0,360)
  o.callback(&pr)

  o = FLTK::Box.new(300, 385, 150, 115, "FLTK::Roller")
  o.box(FLTK::ENGRAVED_BOX)
  o.labelfont(1)
  o.align(FLTK::ALIGN_TOP|FLTK::ALIGN_INSIDE)

  o = FLTK::Roller.new(315, 390, 20, 95, "0")
  o.tooltip("Vertical Roller")
  o.labelsize(8)
  o.step(0.001)
  o.callback(&pr)

  o = FLTK::Roller.new(345, 430, 90, 20, "FLTK::HORIZONTAL")
  o.tooltip("Horizontal Roller")
  o.widget_type(1)
  o.labelsize(8)
  o.step(0.001)
  o.callback(&pr)

  o = FLTK::Box.new(460, 385, 110, 115,
    "Some widgets have color(FLTK::GREEN) and color2(FLTK::RED) to show the areas these effect.")
  o.box(FLTK::BORDER_FRAME)
  o.color(FLTK::FOREGROUND_COLOR)
  o.selection_color(FLTK::FOREGROUND_COLOR)
  o.labelsize(10)
  o.align(FLTK::ALIGN_WRAP)

  message = FLTK::Box.new(0, 510, 580, 30)
  message.box(FLTK::ENGRAVED_BOX)

  win.show
}

FLTK.run
